using System.Collections;
using System.Collections.Generic;
using TMPro;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class GameManager : MonoBehaviour
{
    [SerializeField]
    GameObject prefabTor;
    [SerializeField]
    int modeGame = 5;
    [SerializeField]
    float moveSpeed = 5;
    [SerializeField]
    Camera _camera;
    [SerializeField]
    TextMeshProUGUI score;
    [SerializeField]
    GameObject panel;
    public Texture2D cursorTexture;

    public AudioClip tor_UP;
    public AudioClip tor_DOWN;
    public AudioClip game_WIN;
    [SerializeField] private AudioSource sound_eff_Source;


    private GameObject[] arrTors = null;
    private int[,] posTors = null;
    private GameObject curRing = null;
    private int[,] posWin = null;
    private int n_step;

    // Start is called before the first frame update
    void Start()
    {
        panel.SetActive(false);
        GeneratePosTors();
        Cursor.SetCursor(cursorTexture, Vector2.zero, CursorMode.Auto);
        print("Start");
        posWin = new int[6, 5];
        for (int i = 0; i < 6; i++)
        {
            for (int j = 0; j < 5; j++)
            {
                posWin[i, j] = (5 - i) + j * 6;
            }
        }
        n_step = 0;
        score.text = " : 0";
    }

    // Update is called once per frame
    void Update()
    {
        bool win_yes = false;
        if (panel.active) return;
        if (Input.GetMouseButtonDown(0))
        { //     .
            Vector3 point = new Vector3(_camera.pixelWidth / 2, _camera.pixelHeight / 2, 0); //         .
            Ray ray = _camera.ScreenPointToRay(Input.mousePosition); //       ScreenPointToRay().
            RaycastHit hit;            
            if (Physics.Raycast(ray, out hit))
            { //     ,    .
                int col_x, cur_id;
                if (hit.transform.gameObject.CompareTag("tor"))
                {
                    print(hit.transform.gameObject.GetComponent<Tor>().TorID);
                    if (curRing == null)
                    {
                        col_x = (int)((hit.transform.gameObject.transform.position.x + 3.75) / 1.5);
                        for (int i = 5; i >= 0; i--)
                        {
                            cur_id = posTors[i, col_x];
                            if (cur_id != -1) 
                            {
                                foreach (GameObject tor in arrTors)
                                {
                                    if (tor.GetComponent<Tor>().TorID == cur_id)
                                    {
                                        curRing = tor;
                                        posTors[i, col_x] = -1;
                                        sound_eff_Source.clip = tor_UP;
                                        sound_eff_Source.Play();
                                        break;
                                    }                                    
                                }
                                break;
                            }
                        }
                        Vector3 pos = curRing.transform.position;
                        curRing.GetComponent<Tor>().RingUp(new Vector3(pos.x, 3.25f, pos.z));
                    }
                    else
                    {
                        Vector3 rodPos = hit.transform.gameObject.transform.position;
                        col_x = (int)((rodPos.x + 3.75) / 1.5);
                        for (int i = 0; i < 6; i++) 
                        {
                            if (posTors[i, col_x] == -1)
                            {
                                curRing.GetComponent<Tor>().RingMove(new Vector3(rodPos.x, 3.25f, rodPos.z), new Vector3(rodPos.x, 0.25f + 0.5f * i, rodPos.z));
                                posTors[i, col_x] = curRing.GetComponent<Tor>().TorID;
                                curRing = null;win_yes = isWin();
                                sound_eff_Source.clip = tor_DOWN;
                                sound_eff_Source.Play();
                                break;
                            }
                        }                        
                    }
                } 
                if (hit.transform.gameObject.CompareTag("rod"))
                {
                    if (curRing != null)
                    {
                        Vector3 rodPos = hit.transform.gameObject.transform.position;
                        col_x = (int)((rodPos.x + 3.75) / 1.5);
                        for (int i = 0; i < 6; i++)
                        {
                            if (posTors[i, col_x] == -1)
                            {
                                curRing.GetComponent<Tor>().RingMove(new Vector3(rodPos.x, 3.25f, rodPos.z), new Vector3(rodPos.x, 0.25f + 0.5f * i, rodPos.z));
                                posTors[i, col_x] = curRing.GetComponent<Tor>().TorID;
                                curRing = null; win_yes = isWin();
                                sound_eff_Source.clip = tor_DOWN;
                                sound_eff_Source.Play();
                                break;
                            }
                        }
                    }
                }
            }
        }
        if (win_yes)
        { 
            print("WIN");
            panel.SetActive(true);
            sound_eff_Source.clip = game_WIN;
            sound_eff_Source.Play();
        }
    }

    public void PressedStart()
    {
        SceneManager.LoadScene(SceneManager.GetActiveScene().buildIndex);
    }

    public void PressedExit()
    {
        Application.Quit();
    }

    void GeneratePosTors()
    {
        if (modeGame == 5)
        {
            posTors = new int[6, 6];
            arrTors = new GameObject[30];
            int i;
            for (i = 0; i < 30; i++)
            {
                arrTors[i] = Instantiate(prefabTor, Vector3.zero, Quaternion.identity);
                arrTors[i].GetComponent<Tor>().TorID = i;
                arrTors[i].GetComponent<Tor>().Speed = moveSpeed;
                MeshRenderer mr = arrTors[i].GetComponent<MeshRenderer>();
                Material[] mat = new Material[1];
                mat[0] = mr.materials[i / 6];
                mr.materials = mat;
                arrTors[i].transform.Rotate(90f, 0, 0);
                arrTors[i].transform.localScale = new Vector3((float)(20 * (0.8 + 0.31 * (i % 6))), (float)(20 * (0.8 + 0.31 * (i % 6))), 55.0f);
            }
            Shuffle(arrTors);
            for (i = 0; i < 30; i++)
            {
                posTors[i / 6, i % 6] = arrTors[i].GetComponent<Tor>().TorID;   // y, x
                arrTors[i].transform.position = new Vector3((float)(-3.75 + 1.5 * (i % 6)), 0.25f + 0.5f * (i / 6), 0);
            }
            for (i = 0; i < 6; i++) posTors[5, i] = -1;
        }
    }

    void Shuffle(GameObject[] deck)
    {
        for (int i = 0; i < deck.Length; i++)
        {
            GameObject temp = deck[i];
            int randomIndex = Random.Range(0, deck.Length);
            deck[i] = deck[randomIndex];
            deck[randomIndex] = temp;
        }
    }

    bool isWin()
    {
        n_step++;
        score.text = " : " + n_step.ToString();
        int wn = 0, i, j, col = -1;
        for (i = 0; i < 6; i++)
        {
            if (((posTors[0, i] + 1) % 6) != 0) return false;
        }
        for (i = 0; i < 6; i++)
        {
            col = -1;
            if (posTors[0, i] == -1) continue;
            for (j = 0; j < 5; j++) if (posTors[0, i] == posWin[0, j]) { col = j; break; }   //     5 
            print("num col = " + col);
            if (col == -1) continue;
            for (j = 1; j < 6; j++) 
            {   //    
                if (posTors[j, i] != posWin[j, col]) return false;
            }
            wn |= 1 << col;
        }
        if (wn != 0x1f) return false;
        print("WIN");
        return true;
    }
}
